#include <stdio.h>
#include <stdlib.h>

void	skip_comment(FILE *F)
{
	unsigned char c;
	
	while	(1) {
		do
                  c = fgetc(F);
		while (c == ' ');
			 
		if (c != '#') {
			fseek(F, -1, SEEK_CUR);
			return;
			}
		else	while (fgetc(F) != '\n');
	}
}

int	main(int argc, char *argv[])
{
	int	x,y,sx,sy, sxf, temp, temp2;
	unsigned char	*map, *str;
        int     file, i, j, k;
        int     histo[256];
        int     lg, dg, wh;
        char    tampon[1024];
	
	printf("Usage: pgm2bgs file1.pgm file2.pgm ...\n");

	for(file = 1 ; file < argc ; file++)
		{
                FILE *F = fopen(argv[file],"r");
                printf("Processing file %s...\n",argv[file]);
		if (F == NULL) {
                   printf("FILE %s not found.\n", argv[file]);
                   continue;
                   }
		if (fgetc(F) != 'P' || fgetc(F) != '2' || fgetc(F) != '\n')
			printf("%s file is not a PGM P2 file (Do not use binary PGM)\n", argv[file]);
		else	{
			skip_comment(F);
			if (fscanf(F, "%d", &sx) != 1)
				{
				printf("Unreadable size X\n");
				continue; 	
				}
			skip_comment(F);
			if (fscanf(F, "%d", &sy) != 1)
				{
				printf("Unreadable size Y\n");
				continue; 	
				}
			skip_comment(F);
			if (fscanf(F, "%d", &temp) != 1 || temp != 255)
				{
				printf("Should be 255\n");
				continue; 
				}
                        // Alloc memory
                        sxf = ((sx-1)/16+1)*16;
                        map = malloc(sizeof(char) * sxf*sy);
                        memset(map, 255, sxf*sy);
                        // Clear Histogramme
                        for(i = 0 ; i < 256 ; i++)
                              histo[i] = 0;
                        // Read image
                        for(j = 0 ; j < sy ; j++)
				for(i = 0 ; i < sx ; i++) {
                                        skip_comment(F);
				        if (fscanf(F, "%d", &temp) != 1) {
						printf("Unreadable value.\n");
						exit(1);
					}
					map[j*sxf+i] = temp;
                                        histo[temp]++;
				}
                        fclose(F);

                        // Recherche transition
                        i = 0; dg = 0;
                        while (i < sx*sy/4)
                                i+=histo[dg++];
                        i = 0; lg = dg; dg--;
                        while (i < sx*sy/4)
                                i+=histo[lg++];
                        i = 0; wh = lg; lg--;
                        while (i < sx*sy/4)
                                i+=histo[wh++];
                        wh--;
                        printf("Transition Black-%d-Dark-%d-Light-%d-White\n",
                                           dg, lg, wh);
                        // Write BGS
                        strncpy(tampon, argv[file], 1024);
                        str = tampon;
                        while (*(str++) != '.');
                        *(str++) = 'b';
                        *(str++) = 'i';
                        *(str++) = 'n';

                        F = fopen(tampon, "wb");
                        if (F == NULL) {
                           printf("Cannot open %s\n", argv[i]);
                           continue;
                           }
                        fputc(sy, F);
                        fputc((sx-1)/16+1, F);

                        for( j = 0 ; j < sy ; j++)
                           for( i = 0 ; i < sx ; i+=16)
                              {
                              temp = temp2 = 0;
                              for(k = 0 ; k < 16 ; k++)
                                 {
                                 temp+=temp;
                                 temp2+=temp2;
                                 if (map[j*sxf+i+k] < dg)
                                    {
                                    temp |= 1;
                                    temp2 |= 1;
                                    }
                                 else if (map[j*sxf+i+k] < lg)
                                      temp |=1;
                                 else if (map[j*sxf+i+k] < wh)
                                      temp2 |= 1;
                                 }
                              fputc(temp/256, F);
                              fputc(temp%256, F);
                              fputc(temp2/256, F);
                              fputc(temp2%256, F);
                              }
                        fclose(F);
                        free(map);
		}
			
		}
        return 0;
}